/* eslint-disable semi */
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.API = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
/* eslint-disable no-unused-vars */


var _utils = require('../util/utils');

var _babelCore = require('babel-core');

var _babelPolyfill = require('babel-polyfill');

var babel = _interopRequireWildcard(_babelPolyfill);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/* eslint-enable no-unused-vars */

var LN_API_URL = 'http://www.nationalgeographic.com/bin/services/core/public/query/content.json?contentTypes=adventure/components/pagetypes/story/article,adventure/components/pagetypes/story/gallery,adventure/components/pagetypes/story/interactive,adventure/components/pagetypes/story/multipage,animals/components/pagetypes/story/article,animals/components/pagetypes/story/gallery,animals/components/pagetypes/story/interactive,animals/components/pagetypes/story/multipage,archaeologyandhistory/components/pagetypes/story/article,archaeologyandhistory/components/pagetypes/story/gallery,archaeologyandhistory/components/pagetypes/story/interactive,archaeologyandhistory/components/pagetypes/story/multipage,environment/components/pagetypes/story/article,environment/components/pagetypes/story/gallery,environment/components/pagetypes/story/interactive,environment/components/pagetypes/story/multipage,magazine/components/pagetypes/story/article,magazine/components/pagetypes/story/gallery,magazine/components/pagetypes/story/interactive,magazine/components/pagetypes/story/multipage,news/components/pagetypes/story/article,news/components/pagetypes/story/gallery,news/components/pagetypes/story/interactive,news/components/pagetypes/story/multipage,parks/components/pagetypes/story/article,parks/components/pagetypes/story/gallery,parks/components/pagetypes/story/interactive,parks/components/pagetypes/story/multipage,peopleandculture/components/pagetypes/story/article,peopleandculture/components/pagetypes/story/gallery,peopleandculture/components/pagetypes/story/interactive,peopleandculture/components/pagetypes/story/multipage,photography/components/pagetypes/story/article,photography/components/pagetypes/story/gallery,photography/components/pagetypes/story/interactive,photography/components/pagetypes/story/multipage,science/components/pagetypes/story/article,science/components/pagetypes/story/gallery,science/components/pagetypes/story/interactive,science/components/pagetypes/story/multipage,travel/components/pagetypes/story/article,travel/components/pagetypes/story/gallery,travel/components/pagetypes/story/interactive,travel/components/pagetypes/story/multipage&sort=newest&operator=or&includedTags=&excludedTags=ngs_genres:reference,ngs_visibility:omit_from_hp&excludedGuids=beda7baa-e63b-4276-8122-34e47a4e653e';
var DEFAULT_PAGE_SIZE = 3;

var POD_API_URL = 'https://relay.nationalgeographic.com/proxy/distribution/feed/v1?format=jsonapi&content_type=featured_image&fields=image,uri&collection=fd5444cc-4777-4438-b9d4-5085c0564b44';
var NATGEO_API_USER = 'pod_archive';
var NATGEO_API_KEY = '9fa5d22ad7b354fe0f9be5597bcf153df56e2ca5';
var timeInOneDay = 1000 * 60 * 60 * 24;

var requestOptions = {
  url: undefined,
  method: 'GET',
  headers: {
    'apiauth-apiuser': NATGEO_API_USER,
    'apiauth-apikey': NATGEO_API_KEY
  }
};

var getRequestOptions = function getRequestOptions(url) {
  var options = JSON.parse(JSON.stringify(requestOptions));
  options.url = url;
  return options;
};

var getYesterdayPhoto = function getYesterdayPhoto(callback) {
  var yesterdayDate = new Date();
  yesterdayDate.setDate(yesterdayDate.getDate() - 1);
  var yesterdayString = yesterdayDate.toISOString();
  var day = yesterdayString.substring(0, yesterdayString.indexOf('T'));
  var url = POD_API_URL + '&publication_datetime__from=' + day + 'T00:00:00Z&page=1&limit=1';
  var requestOptions = getRequestOptions(url);

  return (0, _utils.makeRequest)(requestOptions, callback);
};

var API = exports.API = function () {
  function API() {
    _classCallCheck(this, API);
  }

  _createClass(API, null, [{
    key: 'getLatestNews',
    value: function getLatestNews(pageSize, pageNumber, cb) {
      var callback = void 0;
      if (arguments.length === 3) {
        callback = cb;
      } else if (arguments.length === 2) {
        if (Object.prototype.toString.call(arguments[1]) === '[object Function]') {
          callback = pageNumber;
        }
      } else if (arguments.length === 1) {
        if (Object.prototype.toString.call(arguments[0]) === '[object Function]') {
          callback = pageSize;
        }
      }

      var queryPageSize = isNaN(pageSize) ? DEFAULT_PAGE_SIZE : pageSize;
      var queryPageNumber = isNaN(pageNumber) ? 0 : pageNumber;

      var url = LN_API_URL + '&pageSize=' + queryPageSize + '&page=' + queryPageNumber;

      var requestOptions = {
        url: url,
        method: 'GET'
      };

      return (0, _utils.makeRequest)(requestOptions, callback);
    }
  }, {
    key: 'getPhotoOfDay',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(day, cb) {
        var url,
            callback,
            now,
            date,
            targetDate,
            numberOfDays,
            requestOptions,
            result,
            payload,
            _args = arguments;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                url = void 0, callback = void 0;


                if (_args.length === 2) {
                  callback = cb;
                } else if (_args.length === 1) {
                  if (Object.prototype.toString.call(_args[0]) === '[object Function]') {
                    callback = day;
                  }
                }

                if (Object.prototype.toString.call(day) !== '[object String]' || isNaN(Date.parse(day))) {
                  now = new Date().toISOString();
                  date = now.substring(0, now.indexOf('T'));

                  url = POD_API_URL + '&publication_datetime__from=' + date + 'T00:00:00Z&page=1&limit=1';
                } else {
                  targetDate = new Date(day);
                  numberOfDays = Math.floor(Math.abs((Date.now() - targetDate.getTime()) / timeInOneDay));

                  url = POD_API_URL + '&publication_datetime__from=' + day + 'T00:00:00Z&page=' + numberOfDays + '&limit=1';
                }

                requestOptions = getRequestOptions(url);
                _context.next = 6;
                return (0, _utils.makeRequest)(requestOptions);

              case 6:
                result = _context.sent;
                payload = JSON.parse(result);

                if (!(payload.data.length > 0)) {
                  _context.next = 16;
                  break;
                }

                if (!(typeof callback === 'function')) {
                  _context.next = 13;
                  break;
                }

                callback(result);
                _context.next = 14;
                break;

              case 13:
                return _context.abrupt('return', result);

              case 14:
                _context.next = 17;
                break;

              case 16:
                return _context.abrupt('return', getYesterdayPhoto(callback));

              case 17:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getPhotoOfDay(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return getPhotoOfDay;
    }()
  }]);

  return API;
}();